@echo off
setlocal

set COMPAT_KEY="HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers"
set COMPAT_VAL="RUNASADMIN WINXPSP3"
set "TAFOLDER=C:\Program Files (x86)\TransAlarm"

REM Windows-Version ermitteln:
for /f "tokens=4-5 delims=.XP " %%i in ('ver') do set VERSION=%%i.%%j
if "%version%" == "10.0" echo Windows 10 && goto tilde
if "%version%" == "6.3" echo Windows 8.1 && goto tilde
if "%version%" == "6.2" echo Windows 8. && goto tilde
if "%version%" == "6.1" echo Windows 7. && goto bits
if "%version%" == "6.0" echo Windows Vista. && goto modifyxp2
if "%version%" == "5.1" echo Windows XP && goto end

echo FEHLER. Unbekannt: Version %version%
goto end

:modifyxp2
set COMPAT_VAL="RUNASADMIN WINXPSP2"
goto bits

:tilde
set COMPAT_VAL="~ RUNASADMIN WINXPSP3"

:bits
REM Bittigkeit ermitteln:
reg query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" > NUL && set OS=32BIT || set OS=64BIT
if %OS%==64BIT echo 64bit OS && goto modify

REM bei 32-Bit-System Installationspfad anpassen
set "TAFOLDER=C:\Program Files\TransAlarm"

:modify
REG ADD %COMPAT_KEY% /t REG_SZ /d %COMPAT_VAL% /f /v "%TAFOLDER%\TAZAdm.exe"
REG ADD %COMPAT_KEY% /t REG_SZ /d %COMPAT_VAL% /f /v "%TAFOLDER%\gbaksched.exe"
REG ADD %COMPAT_KEY% /t REG_SZ /d %COMPAT_VAL% /f /v "%TAFOLDER%\Kontrollanruflog.exe"
REG ADD %COMPAT_KEY% /t REG_SZ /d %COMPAT_VAL% /f /v "%TAFOLDER%\Taz3Cfg.exe"
REG ADD %COMPAT_KEY% /t REG_SZ /d %COMPAT_VAL% /f /v "%TAFOLDER%\Stationsliste.exe"
REG ADD %COMPAT_KEY% /t REG_SZ /d %COMPAT_VAL% /f /v "%TAFOLDER%\Vorgangsreport.exe"
REG ADD %COMPAT_KEY% /t REG_SZ /d %COMPAT_VAL% /f /v "%TAFOLDER%\TransAlarmSchaltzentrale.exe"
REG ADD %COMPAT_KEY% /t REG_SZ /d %COMPAT_VAL% /f /v "%TAFOLDER%\Diagnose\DebugRecorder.exe"

:end

endlocal
pause
echo on
